<template>
  <main class="ApiKeys">
    <Toolbar class="ApiKeys__Toolbar">
      <template #start>
        <AccountsMenu />
      </template>
      <template #end>
        <form class="ApiKeys__Create" @submit.prevent="create">
          <InputText
            v-model="newKeyUsage"
            :title="t('resource.apiKey.usage')"
            :placeholder="t('resource.apiKey.create')"
          />

          <Button
            v-if="newKeyUsage"
            :title="t('resource.apiKey.create')"
            icon="pi pi-plus"
            type="submit"
            class="p-button-outlined"
          />
        </form>
      </template>
    </Toolbar>

    <Message v-if="newApiKey" severity="success">
      <div class="ApiKeys__SuccessMessage">
        <span>{{ t('page.apiKeys.createSuccess') }}</span>
        <span class="ApiKeys__PlainToken">{{ newApiKey.plainToken }}</span>
        <Button
          icon="mdi mdi-content-copy"
          :label="t('page.apiKeys.copyToken')"
          @click="copyPlainTokenToClipboard"
        />
      </div>
    </Message>

    <TransitionGroup name="fade" tag="ul" class="ApiKeys__List">
      <li v-for="apiKey of apiKeys" :key="apiKey.id" class="ApiKeys__Key">
        <span>{{ apiKey.usage }}</span>
        <Button
          :label="t('action.delete')"
          icon="mdi mdi-delete"
          class="p-button-danger p-button-outlined"
          @click="removeApiKey(apiKey)"
        />
      </li>
    </TransitionGroup>

    <ConfirmDeleteDialog
      v-if="apiKeyToDelete"
      v-model:visible="displayConfirmDelete"
      :resource-name="apiKeyToDelete.usage"
      :uuid="apiKeyToDelete.id"
      resource-key="apiKey"
      @deleted:resource="onDelete($event)"
    />
  </main>
</template>

<script lang="ts" setup>
import AccountsMenu from '../AccountsMenu.vue'
import type { ApiKey, ApiKeyPlainToken } from '@/api'
import { apiKeyClient } from '@/api'
import { onMounted, ref } from 'vue'
import Toolbar from 'primevue/toolbar/Toolbar.vue'
import Button from 'primevue/button/Button.vue'
import InputText from 'primevue/inputtext/InputText.vue'
import Message from 'primevue/message/Message.vue'
import ConfirmDeleteDialog from '@/components/resources/ConfirmDeleteDialog.vue'
import { useI18n } from 'vue-i18n'

const { t } = useI18n()
const apiKeys = ref<ApiKey[]>([])
const newKeyUsage = ref('')
const newApiKey = ref<ApiKeyPlainToken | null>(null)

async function loadApiKeys() {
  let result = await apiKeyClient.getCollection({})
  apiKeys.value = []
  result.resources.forEach((apiKey) => apiKeys.value.push(apiKey))
  if (result.next) {
    result = await result.next()
    result.resources.forEach((apiKey) => apiKeys.value.push(apiKey))
  }
}

async function create() {
  newApiKey.value = await apiKeyClient.create({ usage: newKeyUsage.value })
  await loadApiKeys()
}

function copyPlainTokenToClipboard() {
  if (newApiKey.value) {
    navigator.clipboard.writeText(newApiKey.value.plainToken)
  }
}

const apiKeyToDelete = ref<ApiKey | null>(null)
const displayConfirmDelete = ref(false)

function removeApiKey(apiKey: ApiKey) {
  apiKeyToDelete.value = apiKey
  displayConfirmDelete.value = true
}

/**
 * Remove deleted apiKeys from list
 */
function onDelete(deletedId: ApiKey['id']) {
  let index = apiKeys.value.findIndex((apiKey) => apiKey.id === deletedId)

  if (-1 !== index) {
    apiKeys.value.splice(index, 1)
  }
}

onMounted(() => loadApiKeys())
</script>

<style lang="scss" scoped>
@use 'src/style/variables' as v;
@use 'src/style/mixins' as m;
@use 'src/pages/accounts/accountsView' as av;

.ApiKeys {
  @include av.accountsView();

  &__Create {
    display: inline-flex;
    gap: v.$spacing-2;
  }

  &__PlainToken {
    display: inline-flex;
    width: 100%;
    padding: v.$spacing;
    white-space: pre-wrap;
    word-break: break-all;
  }

  &__List {
    padding: 0;
    list-style: none;
  }

  &__SuccessMessage {
    align-items: center;
  }

  &__Key {
    display: inline-flex;
    align-items: center;
    justify-content: space-between;
    width: 100%;
    padding: v.$spacing;
    border-bottom: 1px solid var(--surface-d);
  }
}
</style>
